﻿using StudentManager.Editor;
using StudentManager.Model;
using System.Configuration;
using System.Data;
using System.Windows;

namespace StudentManager
{
	/// <summary>
	/// Interaction logic for App.xaml
	/// </summary>
	public partial class App : PrismApplication
	{
		protected override Window CreateShell()
		{
			return Container.Resolve<MainEditor>();
		}

		protected override void RegisterTypes(IContainerRegistry containerRegistry)
		{
			containerRegistry.RegisterForNavigation<MainEditor, Students>();
			containerRegistry.RegisterForNavigation<StudentsView>();
			containerRegistry.RegisterForNavigation<QuestionsView>();
			containerRegistry.RegisterForNavigation<CheckView>();
			containerRegistry.RegisterForNavigation<DetailView>();
			containerRegistry.RegisterForNavigation<DetailCheckView>();
			containerRegistry.RegisterForNavigation<AddQuestionView>();
		}
	}

}
