﻿using Google.Protobuf.WellKnownTypes;
using Microsoft.VisualBasic;
using StudentManager.Common;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Text;
using System.Text.Json;
using System.Threading.Tasks;

namespace StudentManager.Data
{
    public static class QuestionLib
    {
		public static string FileName = "questionLib.dbqi";
		public static Dictionary<int, QuestionData> QuestionDic { get; set; } = new Dictionary<int, QuestionData>();
		public static int TotalCount { get; set; } = 0;

		public static int GetQuestionCount()
		{
			TotalCount = QuestionDic.Count;
			return TotalCount;
		}
		public static void Load()
		{
			QuestionDic.Clear();

			Debug.Assert(Path.Exists(StudentLib.LibPath));
			string file = File.ReadAllText(StudentLib.LibPath + FileName);
			QuestionDic = JsonSerializer.Deserialize<Dictionary<int, QuestionData>>(file);
		}
		public static void Save()
		{
			File.WriteAllText((StudentLib.LibPath + FileName), JsonSerializer.Serialize(QuestionDic));
		}

		public static void FreshAllQuestion()
		{
			SQLHelper.Query<QuestionData>().ForEach(x => QuestionDic.Add(x.Id, x));
		}

		public static ObservableCollection<QuestionData> GetAllQuestion()
		{
			var list = new ObservableCollection<QuestionData>();
			foreach (QuestionData data in QuestionDic.Values)
			{
				list.Add(data);
			}
			return list;
		}

		public static QuestionData Get(int id)
		{
			if (!QuestionDic.ContainsKey(id)) return null;

			return QuestionDic[id];
		}

		public static void Add(QuestionData question)
		{
			QuestionDic.Add(question.Id, question);
			SQLHelper.Add(question);
		}

		public static void Remove(QuestionData question)
		{
			if (question == null) throw new NullReferenceException();
			QuestionDic.Remove(question.Id);
		}

		public static void Remove(int id)
		{
			QuestionDic.Remove(id);
		}
	}
}
